<?php

//Add pixel
function overtracking_pixel() {
    $overtrackingconfig = get_option('overtracking_config');
    if (isset($overtrackingconfig['overtrackingcode']) && !empty($overtrackingconfig['overtrackingcode'])) {
        echo "<script defer src=\"https://cdn.overtracking.com/t/{$overtrackingconfig['overtrackingcode']}/\"></script>";
    }
}

add_action('wp_head', 'overtracking_pixel', 1);

//Add product name input
function add_cart_name_hidden_input() {
    $product = wc_get_product();
    if (!$product) {
        return;
    }
    ?>
    <input type="hidden" name="product_name" value="<?php echo $product->get_title(); ?>"/>
    <?php
}

add_action('woocommerce_before_add_to_cart_quantity', 'add_cart_name_hidden_input');

//Add product name to loop button
add_filter('woocommerce_loop_add_to_cart_link', 'quantity_inputs_for_woocommerce_loop_add_to_cart_link', 10, 2);

function quantity_inputs_for_woocommerce_loop_add_to_cart_link($html, $product) {
    if ($product) {
        $html .= '<input type="hidden" name="product_name" id="product-' . $product->get_id() . '" value="' . $product->get_title() . '" />';
    }
    return $html;
}

//Add product name to remove button
add_filter('woocommerce_cart_item_remove_link', 'remove_icon_and_add_text', 10, 2);

function remove_icon_and_add_text($string, $cart_item_key) {

    $cart_item = WC()->cart->get_cart()[$cart_item_key];
    $string .= '<input type="hidden" name="product_name" id="product-' . $cart_item['data']->get_id() . '" value="' . $cart_item['data']->get_title() . '" />';
    return $string;
}

//Cart events
function overtracking_cart() {
    $overtrackingconfig = get_option('overtracking_config');
//Add to cart
    ?>
    <script type="text/javascript">
        window.onload = function () {
    <?php
//Track no ajax add to cart
    if (isset($_POST['quantity']) && isset($overtrackingconfig['events']['add_to_cart']) && count($overtrackingconfig['events']['add_to_cart']) > 0) {
        global $product;
        foreach ($overtrackingconfig['events']['add_to_cart'] as $event) {
            $value = ($event['value'] == 'yes') ? $product->get_id() : ''
            ?>
                    _ovt('<?php echo $event['key']; ?>', '<?php echo $value; ?>');
            <?php
        }
    }
//Add to cart
    if (isset($overtrackingconfig['events']['add_to_cart']) && count($overtrackingconfig['events']['add_to_cart']) > 0) {
        ?>

                function addtocart(value) {

        <?php
        foreach ($overtrackingconfig['events']['add_to_cart'] as $event) {
            if ($event['value'] == 'yes') {
                ?>

                            _ovt('<?php echo $event['key']; ?>', value);
                <?php
            } else {
                ?>
                            _ovt('<?php echo $event['key']; ?>', '');
                <?php
            }
        }
        ?>
                }

                (function ($) {
                    //Add to cart
                    if ($('.single_add_to_cart_button')[0]) {
                        $(".single_add_to_cart_button").on('click', function () {
                            addtocart($('input[name=product_name]').val());
                        });
                    } else {
                        $(document.body).on('added_to_cart', function (event, fragments, cart_hash, $button) {
                            if ($('#product-' + $($button[0]).data('product_id'))[0]) {
                                addtocart($('#product-' + $($button[0]).data('product_id')).val());
                            } else
                            {
                                addtocart($($button[0]).data('product_id'));
                            }
                        });
                    }
                })(jQuery);
        <?php
    }
//Remove from cart
    if (isset($overtrackingconfig['events']['remove_from_cart']) && count($overtrackingconfig['events']['remove_from_cart']) > 0) {
        ?>
                function removefromcart(value) {
        <?php
        foreach ($overtrackingconfig['events']['remove_from_cart'] as $event) {
            if ($event['value'] == 'yes') {
                ?>
                            _ovt('<?php echo $event['key']; ?>', value);
                <?php
            } else {
                ?>
                            _ovt('<?php echo $event['key']; ?>', '');
                <?php
            }
        }
        ?>
                }
                (function ($) {
                    //Remove on mini cart
                    $(document.body).on('removed_from_cart', function (event, fragments, cart_hash, $button) {
                        if ($('#product-' + $($button[0]).data('product_id'))[0]) {
                            removefromcart($('#product-' + $($button[0]).data('product_id')).val());
                        } else
                        {
                            removefromcart($($button[0]).data('product_id'));
                        }
                    });
                    //Remove on cart page
                    $('.remove').on('click', function () {
                        var idproduct = $(this).attr('data-product_id');
                        if ($('#product-' + idproduct)[0]) {
                            removefromcart($('#product-' + idproduct).val());
                        } else
                        {
                            removefromcart(idproduct);
                        }
                    });
                })(jQuery);
        <?php
    }
//Add coupon
    if (isset($overtrackingconfig['events']['add_coupon']) && count($overtrackingconfig['events']['add_coupon']) > 0) {
        ?>
                function addcoupon(value) {
        <?php
        foreach ($overtrackingconfig['events']['add_coupon'] as $event) {
            if ($event['value'] == 'yes') {
                ?>
                            _ovt('<?php echo $event['key']; ?>', value);
                <?php
            } else {
                ?>
                            _ovt('<?php echo $event['key']; ?>', '');
                <?php
            }
        }
        ?>
                }
                (function ($) {
        <?php
//Track no ajax add coupon
        if (isset($_POST['coupon_code'])) {
            ?>
                        addcoupon('<?php echo sanitize_text_field($_POST['coupon_code']) ?>');
            <?php
        }
        ?>
                    //Add Ajax coupon
                    $(document.body).on('applied_coupon', function (event, coupon) {
                        addcoupon(coupon);
                    });
                    //Add Ajax coupon in checkout
                    $(document.body).on('applied_coupon_in_checkout', function (event, coupon) {
                        addcoupon(coupon);
                    });
                })(jQuery);
        <?php
    }
//Initiate checkout
    if (is_checkout() && !is_wc_endpoint_url()) {
        if (isset($overtrackingconfig['events']['checkout']) && count($overtrackingconfig['events']['checkout']) > 0) {
            global $woocommerce;
            $cart = $woocommerce->cart;
            $total = $cart->total;
            foreach ($overtrackingconfig['events']['checkout'] as $event) {
                if ($event['value'] == 'yes') {
                    ?>
                            _ovt('<?php echo $event['key']; ?>', '<?php echo $total; ?>');
                    <?php
                } else {
                    ?>
                            _ovt('<?php echo $event['key']; ?>', '');
                    <?php
                }
            }
        }
    }
    //View product
    if (is_product() && isset($overtrackingconfig['events']['view_product']) && count($overtrackingconfig['events']['view_product']) > 0) {
       
        global $product;
        foreach ($overtrackingconfig['events']['view_product'] as $event) {
            $value = ($event['value'] == 'yes') ? $product->get_id() : '';
            ?>
                    _ovt('<?php echo $event['key']; ?>', '<?php echo $value; ?>');
            <?php
        }
       
    }

//View category
    if (is_product_category() && isset($overtrackingconfig['events']['view_category']) && count($overtrackingconfig['events']['view_category']) > 0) {
        $cate = get_queried_object();
        $catid = $cate->term_id;
        foreach ($overtrackingconfig['events']['view_category'] as $event) {
            $value = ($event['value'] == 'yes') ? $catid : '';
            ?>
                    _ovt('<?php echo $event['key']; ?>', '<?php echo $value; ?>');
            <?php
        }
    }
//Search events
    if (is_search() && isset($overtrackingconfig['events']['search']) && count($overtrackingconfig['events']['search']) > 0) {

        foreach ($overtrackingconfig['events']['search'] as $event) {
            $value = ($event['value'] == 'yes') ? sanitize_text_field($_GET['s']) : '';
            ?>
                    _ovt('<?php echo $event['key']; ?>', '<?php echo $value; ?>');
            <?php
        }
    }
    ?>
        };

    </script>
    <?php
}

//Cart events
add_action('wp_footer', 'overtracking_cart');


//Order events
function overtracking_order_completed() {
    $overtrackingconfig = get_option('overtracking_config');
    if (is_order_received_page()) {
        global $wp, $order;
// Get the order ID
        $order_id = absint($wp->query_vars['order-received']);
        $order = new WC_Order($order_id);
        ?>
        <script type="text/javascript">
            window.onload = function () {
        <?php
        if (isset($overtrackingconfig['events']['order_completed']) && count($overtrackingconfig['events']['order_completed']) > 0) {
            foreach ($overtrackingconfig['events']['order_completed'] as $event) {
                $value = ($event['value'] == 'yes') ? $order->total : '';
                ?>
                        _ovt('<?php echo $event['key']; ?>', '<?php echo $value; ?>');
                <?php
            }
        }
//Coupons
        if ($order->get_items('coupon') && isset($overtrackingconfig['events']['used_coupon']) && count($overtrackingconfig['events']['used_coupon']) > 0) {
            foreach ($overtrackingconfig['events']['used_coupon'] as $event) {

                foreach ($order->get_items('coupon') as $item) {
                    $value = ($event['value'] == 'yes') ? $item->get_code() : '';
                    ?>
                            _ovt('<?php echo $event['key']; ?>', '<?php echo $value; ?>');
                    <?php
                }
                ?>

                <?php
            }
        }
//Payment method
        if (isset($overtrackingconfig['events']['payment_method']) && count($overtrackingconfig['events']['payment_method']) > 0) {
            foreach ($overtrackingconfig['events']['payment_method'] as $event) {
                $value = ($event['value'] == 'yes') ? $order->get_payment_method() : '';
                ?>
                        _ovt('<?php echo $event['key']; ?>', '<?php echo $value; ?>');
                <?php
            }
        }
        ?>
            };

        </script>
        <?php
    }
}

add_action('wp_footer', 'overtracking_order_completed');

