<?php

/*
  Plugin Name: Overtracking
  Plugin URI: https://overtracking.com/
  Description: Connect your WordPress site and you Woocommerce store with Overtracking
  Version: 1.03
  Author: Overtracking
  Author URI: https://overtracking.com/
  Text Domain: overtracking
  Domain Path: /languages
 */

/*  Copyright 2024  Overtracking */
//Define variables
define('FILE_OVT_URL', plugin_dir_url(__FILE__));
define('FILEPATH_OVT', plugin_dir_path(__FILE__));
define('PLUGIN_OVT_DOMAIN', 'https://dw.overtracking.com/');
const LOGO_OVT = FILE_OVT_URL . "assets/images/logo.svg";
$events=['order_completed'=>__("Order completed", 'overtracking'),'checkout'=>__("Initiate checkout", 'overtracking'),'add_coupon'=>__("Add coupon to checkout", 'overtracking'),'payment_method'=>__("Payment method", 'overtracking'),'used_coupon'=>__("Used coupon (Order completed)", 'overtracking'),'add_to_cart'=>__("Add to cart", 'overtracking'),'remove_from_cart'=>__("Remove product", 'overtracking'),'view_product'=>__("View product", 'overtracking'),'view_category'=>__("View product category", 'overtracking'),'search'=>__("Search", 'overtracking')];
//Load language
load_plugin_textdomain('overtracking', false, dirname(plugin_basename(__FILE__)) . '/languages/');
//Load functions
include('inc/functions.php');
//Load functions
include('inc/events.php');
//Uninstall actions
register_deactivation_hook(__FILE__, 'overtracking_uninstall');
function overtracking_uninstall() {
    //Delete option
    delete_option('overtracking_config');
}
//Init menu
function overtracking_menu() {
    add_menu_page('Overtracking', 'Overtracking', 'manage_options', 'overtracking', 'overtracking_init', FILE_OVT_URL . "assets/images/favicon-ovt.png");
    add_submenu_page('overtracking', __('Settings'), __('Settings'), 'manage_options', 'settingsovertracking', 'overtracking_settings');
    add_submenu_page(null, __('Delete event', 'overtracking'), null, 'manage_options', 'deleteovertrackingevent', 'overtracking_deleteevent');
    remove_submenu_page('overtracking', 'overtracking');
}

add_action('admin_menu', 'overtracking_menu');
//Settings on plugin list
add_filter('plugin_action_links_overtracking/overtracking.php', 'overtracking_settings_link');
function overtracking_settings_link($links) {
    $url = esc_url(add_query_arg(
                    'page', 'settingsovertracking', get_admin_url() . 'admin.php'
            ));
    $settings_link = "<a href=\"{$url}\">" . __('Settings') . "</a>";
    array_push(
            $links, $settings_link
    );
    return $links;
}
